package com.ibm.http.test;

import java.io.IOException;
import java.util.Iterator;
import java.util.ResourceBundle;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.*;

import javax.servlet.ServletException;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;
import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.servlet.sip.SipApplicationSession;
import javax.servlet.sip.SipFactory;
import javax.servlet.sip.SipServlet;
import javax.servlet.sip.SipServletRequest;
import javax.servlet.sip.SipSession;
import javax.servlet.sip.SipURI;


import com.ibm.websphere.servlet.session.IBMApplicationSession;
import com.ibm.websphere.servlet.session.IBMSession;
import com.ibm.sip.test.DemoAdapterListener;
import com.ibm.sip.test.DemoAdapterSIP;

import com.sirf.studio.geoagent.*;
import com.sirf.studio.app.context.*;
import com.sirf.studio.geoagent.impl.*;
import com.sirf.studio.geoagent.factory.*;
import com.sirf.studio.app.*;
import com.sirf.studio.server.*;
import com.sirf.studio.geoservices.*;
import com.sirf.studio.location.*;
import com.sirf.studio.infrastructure.logger.SSLogger;
import com.sirf.studio.infrastructure.logger.SSCategory;
import  com.sirf.studio.context.*;
import  com.sirf.studio.geoagent.exception.*;

/**
 * Servlet implementation class for Servlet: DemoAdapterHTTP
 *
 */
 public class DemoAdapterHTTP extends javax.servlet.http.HttpServlet implements javax.servlet.Servlet {
	 
	 private DemoAdapterListener listener;
	 private GeoAlert alert = null;
	 private Location loc = null;
	 private User user1 = null;
	 
	 /*
	  * Handles aquisition of the sip factory object
	  * @see javax.servlet.GenericServlet#init()
	  */
	 public void init() throws ServletException {
		 System.out.println("DemoAdapterHTTP init");
		 GeoAgentFactory _fac = GeoAgentFactory.getInstance();
		 user1 = _fac.createUser("User1","123456789012345", 1,11); 
		 alert = _fac.createGeoAlert("Alert1", "Alert Message1",new Date());
		 //loc = new Location();
		 listener = DemoAdapterListener.getInstance();
	 }
	
		protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
			HttpSession httpSession=req.getSession();
			IBMSession extSession = (IBMSession)httpSession;
			IBMApplicationSession ibmAppSession = extSession.getIBMApplicationSession();
			SipApplicationSession appSession = (SipApplicationSession)ibmAppSession ;
			
			String user = req.getParameter("user");
			String alertMessage = req.getParameter("alertMessage");

			if((user!=null) &&( alertMessage !=null)){
				resp.getWriter().print("creating zone alert for User "+user+" with message: "+alertMessage);
				user1.setMsid(user);
				alert.setAlertMessage(alertMessage);
				System.out.println("Sending alert for user "+ user + " with message "+ alertMessage);
				listener.testOnlyAlertTriggered(user1,alert);
			}
			else{
				// Load the initial page.
				resp.setContentType("text/html");
				resp.getWriter().print("Demo Adapter <BR><hr>");
				resp.getWriter().print("Zone Alert info: <BR>");
				resp.getWriter().print("<form>");
				resp.getWriter().print("	User: <input type=\"text\" name=\"user\"> ");
				resp.getWriter().print("	<br>");
				resp.getWriter().print("	Zone Change Description: <input type=\"text\" name=\"alertMessage\"> ");
				resp.getWriter().print("	<input type=\"submit\" value=\"Publish\">");
				resp.getWriter().print("</form>");
			}
		}  

}